searchNodes=[{"doc":"Analyzer takes in a valid repo URL and coordinates the analysis, returning a simple JSON report. The URL can be one of &quot;https&quot;, &quot;http&quot;, or &quot;file&quot;. Note, that the latter scheme will only work an existing clone and won't remove the directory structure upon completion of analysis.","ref":"AnalyzerModule.html","title":"AnalyzerModule","type":"module"},{"doc":"","ref":"AnalyzerModule.html#analyze/3","title":"AnalyzerModule.analyze/3","type":"function"},{"doc":"analyze/3: returns the LowEndInsight report as JSON for multiple_repos. Takes in a &quot;list&quot; of urls, a source id for the calling client, and the start_time of analysis as an optional way to capture the time actually started at whatever the client is (e.g. an async API). Returns Map. Examples iex&gt; { :ok , report } = AnalyzerModule . analyze ( [ &quot;https://github.com/kitplummer/xmpp4rails&quot; , &quot;https://github.com/kitplummer/lita-cron&quot; ] , &quot;iex&quot; ) iex&gt; _count = report [ :metadata ] [ :repo_count ] 2","ref":"AnalyzerModule.html#analyze/4","title":"AnalyzerModule.analyze/4","type":"function"},{"doc":"create_empty_report/3: takes in a uuid, list of urls, and a start time and produces the repo report object to be returned immediately by asynchronous requestors (e.g. LowEndInsight-Get HTTP endpoint)","ref":"AnalyzerModule.html#create_empty_report/3","title":"AnalyzerModule.create_empty_report/3","type":"function"},{"doc":"determine_risk_counts/1: takes in a full report of n-repo reports, and calculates the number or risk ratings, given the number of repos. It returns a new report with the risk_counts object populated with the count table. Have to accommodate both the atom and string elements, because the JSON gets parsed into the string format - so caching can be supported (as reports are stored in JSON).","ref":"AnalyzerModule.html#determine_risk_counts/1","title":"AnalyzerModule.determine_risk_counts/1","type":"function"},{"doc":"determine_toplevel_risk/1: takes in a report and determines the highest criticality, and assigns it to the &quot;risk&quot; element for the repo report.","ref":"AnalyzerModule.html#determine_toplevel_risk/1","title":"AnalyzerModule.determine_toplevel_risk/1","type":"function"},{"doc":"","ref":"Contributor.html","title":"Contributor","type":"module"},{"doc":"","ref":"Contributor.html#t:t/0","title":"Contributor.t/0","type":"type"},{"doc":"","ref":"CounterAgent.html","title":"CounterAgent","type":"module"},{"doc":"","ref":"CounterAgent.html#click/1","title":"CounterAgent.click/1","type":"function"},{"doc":"","ref":"CounterAgent.html#get/1","title":"CounterAgent.get/1","type":"function"},{"doc":"","ref":"CounterAgent.html#new/0","title":"CounterAgent.new/0","type":"function"},{"doc":"","ref":"CounterAgent.html#set/2","title":"CounterAgent.set/2","type":"function"},{"doc":"","ref":"Data.html","title":"Data","type":"module"},{"doc":"Collection of lower-level functions for analyzing outputs from git command.","ref":"GitHelper.html","title":"GitHelper","type":"module"},{"doc":"get_avg_tag_commit_tim_diff / 1 : return the average time between commits within each subarray representing a tag","ref":"GitHelper.html#get_avg_tag_commit_time_diff/1","title":"GitHelper.get_avg_tag_commit_time_diff/1","type":"function"},{"doc":"get_contributor_counts / 1 : Gets the number of contributions belonging to each author and return a map of %{ name = &gt; number }","ref":"GitHelper.html#get_contributor_counts/1","title":"GitHelper.get_contributor_counts/1","type":"function"},{"doc":"det_filtered_contributor_count / 2 : Gets the resolved list of contributers , return count and list","ref":"GitHelper.html#get_filtered_contributor_count/2","title":"GitHelper.get_filtered_contributor_count/2","type":"function"},{"doc":"get_total_tag_commit_time_diff / 1 : return the total time between commits within each subarray representing a tag","ref":"GitHelper.html#get_total_tag_commit_time_diff/1","title":"GitHelper.get_total_tag_commit_time_diff/1","type":"function"},{"doc":"parse_diff / 1 : returns the relevant information contained in the last array position of a diff array","ref":"GitHelper.html#parse_diff/1","title":"GitHelper.parse_diff/1","type":"function"},{"doc":"","ref":"GitHelper.html#parse_header/1","title":"GitHelper.parse_header/1","type":"function"},{"doc":"","ref":"GitHelper.html#parse_shortlog/1","title":"GitHelper.parse_shortlog/1","type":"function"},{"doc":"split_commits_by_tag / 1 : returns a list with sublists arranged by tag","ref":"GitHelper.html#split_commits_by_tag/1","title":"GitHelper.split_commits_by_tag/1","type":"function"},{"doc":"","ref":"GitHelper.html#t:contrib_count/0","title":"GitHelper.contrib_count/0","type":"type"},{"doc":"Collections of functions for interacting with the git command to perform queries.","ref":"GitModule.html","title":"GitModule","type":"module"},{"doc":"clone_repo/2: clones the repo","ref":"GitModule.html#clone_repo/2","title":"GitModule.clone_repo/2","type":"function"},{"doc":"","ref":"GitModule.html#delete_repo/1","title":"GitModule.delete_repo/1","type":"function"},{"doc":"","ref":"GitModule.html#get_clean_contributions_map/1","title":"GitModule.get_clean_contributions_map/1","type":"function"},{"doc":"get_commit_dates/1: returns a list of unix timestamps representing commit times","ref":"GitModule.html#get_commit_dates/1","title":"GitModule.get_commit_dates/1","type":"function"},{"doc":"get_contributions_map/1: returns a map of contributions per git user note: this map is unfiltered, dupes aren't identified","ref":"GitModule.html#get_contributions_map/1","title":"GitModule.get_contributions_map/1","type":"function"},{"doc":"get_contributors_count/1: returns the number of contributors for a given Git repo","ref":"GitModule.html#get_contributor_count/1","title":"GitModule.get_contributor_count/1","type":"function"},{"doc":"","ref":"GitModule.html#get_contributor_distribution/1","title":"GitModule.get_contributor_distribution/1","type":"function"},{"doc":"","ref":"GitModule.html#get_contributors/1","title":"GitModule.get_contributors/1","type":"function"},{"doc":"get_default_branch/1: returns the default branch of the remote repo","ref":"GitModule.html#get_default_branch/1","title":"GitModule.get_default_branch/1","type":"function"},{"doc":"get_last_n_commits/2: returns a list of lines generated from the diff of two commits","ref":"GitModule.html#get_diff_2_commits/2","title":"GitModule.get_diff_2_commits/2","type":"function"},{"doc":"","ref":"GitModule.html#get_functional_contributors/1","title":"GitModule.get_functional_contributors/1","type":"function"},{"doc":"get_current_hash/1: returns the hash of the repo's HEAD","ref":"GitModule.html#get_hash/1","title":"GitModule.get_hash/1","type":"function"},{"doc":"get_last_2_delta/1: returns the lines changed, files changed, additions and deletions in the last commit","ref":"GitModule.html#get_last_2_delta/1","title":"GitModule.get_last_2_delta/1","type":"function"},{"doc":"get_last_commit_date/1: returns the date of the last commit","ref":"GitModule.html#get_last_commit_date/1","title":"GitModule.get_last_commit_date/1","type":"function"},{"doc":"get_last_n_commits/1: returns a list of the short hashes of the last n commits","ref":"GitModule.html#get_last_n_commits/2","title":"GitModule.get_last_n_commits/2","type":"function"},{"doc":"get_recent_changes/1: returns the percentage of changed lines in the last commit by the total lines in the repo","ref":"GitModule.html#get_recent_changes/1","title":"GitModule.get_recent_changes/1","type":"function"},{"doc":"get_repo/1: gets a repo by path, returns Repository struct","ref":"GitModule.html#get_repo/1","title":"GitModule.get_repo/1","type":"function"},{"doc":"","ref":"GitModule.html#get_repo_size/1","title":"GitModule.get_repo_size/1","type":"function"},{"doc":"get_tag_and_commit_dates/1: returns a list of lists of unix timestamps representing commit times with each lsit belonging to a different tag","ref":"GitModule.html#get_tag_and_commit_dates/1","title":"GitModule.get_tag_and_commit_dates/1","type":"function"},{"doc":"get_top10_contributors_map / 1 : Gets the top 10 contributors and returns it as a list of contributors with the commits list stripped from the map .","ref":"GitModule.html#get_top10_contributors_map/1","title":"GitModule.get_top10_contributors_map/1","type":"function"},{"doc":"get_total_lines/1: returns the total lines and files contained in a repo as of the latest commit","ref":"GitModule.html#get_total_lines/1","title":"GitModule.get_total_lines/1","type":"function"},{"doc":"Collection of generic helper functions.","ref":"Helpers.html","title":"Helpers","type":"module"},{"doc":"convert_config_to_list/1: takes in Application.get_all_env(:app) and returns a list of maps, to be encoded as JSON. Since JSON doesn't have an equivalent tuple type the libs all bonk on encoding config values.","ref":"Helpers.html#convert_config_to_list/1","title":"Helpers.convert_config_to_list/1","type":"function"},{"doc":"","ref":"Helpers.html#count_forward_slashes/1","title":"Helpers.count_forward_slashes/1","type":"function"},{"doc":"get_slug/1: extracts the slug from the provided URI argument and returns the path Example iex(1)&gt; { :ok , slug } = Helpers . get_slug ( &quot;https://github.com/kitplummer/xmpprails&quot; ) { :ok , &quot;kitplummer/xmpprails&quot; } iex(2)&gt; slug &quot;kitplummer/xmpprails&quot;","ref":"Helpers.html#get_slug/1","title":"Helpers.get_slug/1","type":"function"},{"doc":"remove_git_prefix/1: removes the git+ prefix found in some public Git URLs","ref":"Helpers.html#remove_git_prefix/1","title":"Helpers.remove_git_prefix/1","type":"function"},{"doc":"split_slug/1: splits apart the username and repo from a git slug returning discrete stings. Examples iex(6)&gt; { :ok , org , repo } = Helpers . split_slug ( &quot;kitplummer/xmpprails&quot; ) { :ok , &quot;kitplummer&quot; , &quot;xmpprails&quot; } iex(7)&gt; org &quot;kitplummer&quot; iex(8)&gt; repo &quot;xmpprails&quot;","ref":"Helpers.html#split_slug/1","title":"Helpers.split_slug/1","type":"function"},{"doc":"validate_url/1: validates field is a valid url. Examples iex&gt; &quot;https:://www.url.com&quot; ...&gt; |&gt; Helpers . validate_url ( ) { :error , &quot;invalid URI path&quot; } iex&gt; &quot;https://github.com/&quot; ...&gt; |&gt; Helpers . validate_url ( ) :ok iex&gt; &#39;&quot;https://&quot;https://www.google.com&quot;&#39; ...&gt; |&gt; Helpers . validate_url ( ) { :error , &quot;invalid URI&quot; } iex&gt; &quot;zipbooks.com&quot; ...&gt; |&gt; Helpers . validate_url ( ) { :error , &quot;invalid URI&quot; } iex&gt; &quot;https://zipbooks..com&quot; ...&gt; |&gt; Helpers . validate_url ( ) { :error , &quot;invalid URI host&quot; }","ref":"Helpers.html#validate_url/1","title":"Helpers.validate_url/1","type":"function"},{"doc":"validate_urls/1: validates a list of urls Examples iex&gt; [ &quot;http://www.google.com&quot; , &quot;http://www.test.com&quot; ] ...&gt; |&gt; Helpers . validate_urls ( ) :ok iex&gt; [ &quot;https://zipbooks..com&quot; , &quot;http://www.test.com&quot; ] ...&gt; |&gt; Helpers . validate_urls ( ) { :error , &quot;invalid URI&quot; } iex&gt; [ &quot;https//github.com/kitplummer/xmpp4rails&quot; , &quot;https://www.zipbooks.com&quot; , &quot;http://www.test.com&quot; ] ...&gt; |&gt; Helpers . validate_urls ( ) { :error , &quot;invalid URI&quot; } iex&gt; &quot;https://zipbooks.com&quot; ...&gt; |&gt; Helpers . validate_urls ( ) { :error , &quot;invalid URI&quot; }","ref":"Helpers.html#validate_urls/1","title":"Helpers.validate_urls/1","type":"function"},{"doc":"Provides map to json encoder","ref":"Hex.Encoder.html","title":"Hex.Encoder","type":"module"},{"doc":"","ref":"Hex.Encoder.html#lockfile_json/1","title":"Hex.Encoder.lockfile_json/1","type":"function"},{"doc":"","ref":"Hex.Encoder.html#lockfile_map/1","title":"Hex.Encoder.lockfile_map/1","type":"function"},{"doc":"","ref":"Hex.Encoder.html#mixfile_json/1","title":"Hex.Encoder.mixfile_json/1","type":"function"},{"doc":"","ref":"Hex.Encoder.html#mixfile_map/1","title":"Hex.Encoder.mixfile_map/1","type":"function"},{"doc":"","ref":"Hex.Library.html","title":"Hex.Library","type":"module"},{"doc":"","ref":"Hex.Library.html#t:t/0","title":"Hex.Library.t/0","type":"type"},{"doc":"Provides mix.lock dependency parser From: https://github.com/librariesio/mix-deps-json/blob/master/lib/lockfile.ex","ref":"Hex.Lockfile.html","title":"Hex.Lockfile","type":"module"},{"doc":"","ref":"Hex.Lockfile.html#parse!/2","title":"Hex.Lockfile.parse!/2","type":"function"},{"doc":"Provides mix.exs dependency parser From: https://github.com/librariesio/mix-deps-json/blob/master/lib/mixfile.ex","ref":"Hex.Mixfile.html","title":"Hex.Mixfile","type":"module"},{"doc":"Scanner scans for mix dependencies to run analysis on.","ref":"Hex.Scanner.html","title":"Hex.Scanner","type":"module"},{"doc":"scan: takes in a path to mix dependencies and returns the dependencies mapped to their analysis and the number of dependencies.","ref":"Hex.Scanner.html#scan/2","title":"Hex.Scanner.scan/2","type":"function"},{"doc":"Printed when the user requests mix help echo","ref":"Mix.Tasks.Echo.html","title":"Mix.Tasks.Echo","type":"task"},{"doc":"This is used to run a LowEndInsight scan against a repository, by cloning it locally, then looking into it. Pass in the repo URL as a parameter to the task. #Usage mix lei . analyze &quot;https://github.com/kitplummer/xmpp4rails&quot; | jq This will return a basic report (prettied by jq) as an Elixir Map. { &quot;data&quot; : { &quot;commit_currency_risk&quot; : &quot;critical&quot; , &quot;commit_currency_weeks&quot; : 563 , &quot;contributor_count&quot; : 1 , &quot;contributor_risk&quot; : &quot;critical&quot; , &quot;functional_contributor_names&quot; : [ &quot;Kit Plummer&quot; ] , &quot;functional_contributors&quot; : 1 , &quot;functional_contributors_risk&quot; : &quot;critical&quot; , &quot;large_recent_commit_risk&quot; : &quot;low&quot; , &quot;recent_commit_size_in_percent_of_codebase&quot; : 0.003683241252302026 , &quot;repo&quot; : [ &quot;https://github.com/kitplummer/xmpp4rails&quot; ] , &quot;risk&quot; : &quot;critical&quot; } , &quot;header&quot; : { &quot;duration&quot; : 1 , &quot;end_time&quot; : &quot;2019-10-24 16:21:56.252768Z&quot; , &quot;source_client&quot; : &quot;mix task&quot; , &quot;start_time&quot; : &quot;2019-10-24 16:21:55.692010Z&quot; , &quot;uuid&quot; : &quot;659b37a2-f67a-11e9-ab5d-88e9fe666193&quot; } }","ref":"Mix.Tasks.Lei.Analyze.html","title":"Mix.Tasks.Lei.Analyze","type":"task"},{"doc":"","ref":"Mix.Tasks.Lei.BatchBulkAnalyze.html","title":"Mix.Tasks.Lei.BatchBulkAnalyze","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Lei.BatchBulkAnalyze.html#run/1","title":"Mix.Tasks.Lei.BatchBulkAnalyze.run/1","type":"function"},{"doc":"This is used to run a LowEndInsight scan against a repository, by cloning it locally, then looking into it. Pass in the repo URL as a parameter to the task. Skipping validation is possible: ➜ lowendinsight git:(develop) ✗ mix lei.bulk_analyze test/fixtures/npm.short.csv invalid file contents ➜ lowendinsight git:(develop) ✗ mix lei.bulk_analyze test/fixtures/npm.short.csv no_validation 11:45:39.773 [error] Not a Git repo URL, is a subdirectory 11:45:40.102 [info] Cloned -&gt; 3: git+ https://github.com/SuzuNohara/zzzROOTPreloader.git 11:45:40.134 [info] Cloned -&gt; 7: git+ https://github.com/zenghongyang/test.git 11:45:40.177 [info] Cloned -&gt; 5: git+ https://github.com/chameleonbr/zzzz-test-module.git #Usage cat url_list | mix lei . bulk_analyze | jq This will return a big report (prettied by jq), depending on your list quantity. { &quot;state&quot; : &quot;complete&quot; , &quot;report&quot; : { &quot;uuid&quot; : &quot;2916881c-67d7-11ea-be2b-88e9fe666193&quot; , &quot;repos&quot; : [ { &quot;header&quot; : { &quot;uuid&quot; : &quot;25b55c30-67d6-11ea-9764-88e9fe666193&quot; , &quot;start_time&quot; : &quot;2020-03-16T22:32:45.324687Z&quot; , &quot;source_client&quot; : &quot;mix task&quot; , &quot;library_version&quot; : &quot;&quot; , &quot;end_time&quot; : &quot;2020-03-16T22:33:24.152148Z&quot; , &quot;duration&quot; : 39 } , &quot;data&quot; : { &quot;risk&quot; : &quot;high&quot; , &quot;results&quot; : { &quot;top10_contributors&quot; : [ { ...","ref":"Mix.Tasks.Lei.BulkAnalyze.html","title":"Mix.Tasks.Lei.BulkAnalyze","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Lei.BulkAnalyze.html#run/1","title":"Mix.Tasks.Lei.BulkAnalyze.run/1","type":"function"},{"doc":"This is used to run LowEndInsight to generate a transitive-dependency list, as JSON, for a given repository. #Usage mix lei . dependencies This will return a JSON arrary of all dependencies for a given repository. The list is generated from the project's mix.lock file.","ref":"Mix.Tasks.Lei.Dependencies.html","title":"Mix.Tasks.Lei.Dependencies","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Lei.Dependencies.html#run/1","title":"Mix.Tasks.Lei.Dependencies.run/1","type":"function"},{"doc":"This is used to run a LowEndInsight scanner against a project. #Usage mix lei . scan This will return a basic list of reports in JSON format. LowEndInsight will scan the mix.exs file for the list of dependencies, enumerating through them and fetching the source repo URL from the Hex.pm API. Then the scanner passes that URL to LowEndInsight which does a temporary clone to perform its analysis of each dependency.","ref":"Mix.Tasks.Lei.Scan.html","title":"Mix.Tasks.Lei.Scan","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Lei.Scan.html#run/1","title":"Mix.Tasks.Lei.Scan.run/1","type":"function"},{"doc":"Provides package.json and package-lock.json dependency parser","ref":"Npm.Packagefile.html","title":"Npm.Packagefile","type":"module"},{"doc":"Scanner scans for node dependencies to run analysis on.","ref":"Npm.Scanner.html","title":"Npm.Scanner","type":"module"},{"doc":"query_npm: function that takes in a package and returns an analysis on that package's repository using analyser_module. If the package url cannot be reached, an error is returned.","ref":"Npm.Scanner.html#query_npm/1","title":"Npm.Scanner.query_npm/1","type":"function"},{"doc":"scan: called when node? is false, returning an empty list and 0","ref":"Npm.Scanner.html#scan/2","title":"Npm.Scanner.scan/2","type":"function"},{"doc":"scan: takes in a path to node dependencies and returns the dependencies mapped to their analysis and the number of dependencies","ref":"Npm.Scanner.html#scan/3","title":"Npm.Scanner.scan/3","type":"function"},{"doc":"Provides yarn.lock dependency parser","ref":"Npm.Yarnlockfile.html","title":"Npm.Yarnlockfile","type":"module"},{"doc":"","ref":"Parser.html","title":"Parser","type":"behaviour"},{"doc":"","ref":"Parser.html#c:file_names/0","title":"Parser.file_names/0","type":"callback"},{"doc":"","ref":"Parser.html#c:parse!/1","title":"Parser.parse!/1","type":"callback"},{"doc":"ProjectIdent module","ref":"ProjectIdent.html","title":"ProjectIdent","type":"module"},{"doc":"categorize_repo/1: takes in a Repository and will return a list of found project types within the repo.","ref":"ProjectIdent.html#categorize_repo/2","title":"ProjectIdent.categorize_repo/2","type":"function"},{"doc":"find_files: Traverses paths according to the given repository and project type and returns a list of matches","ref":"ProjectIdent.html#find_files/2","title":"ProjectIdent.find_files/2","type":"function"},{"doc":"get_project_types_identified: takes in a Repository and will return a list of maps of found project types within the repo.","ref":"ProjectIdent.html#get_project_types_identified/1","title":"ProjectIdent.get_project_types_identified/1","type":"function"},{"doc":"","ref":"ProjectType.html","title":"ProjectType","type":"module"},{"doc":"","ref":"ProjectType.html#types_to_string/1","title":"ProjectType.types_to_string/1","type":"function"},{"doc":"Provides a requirements.txt dependency parser","ref":"Pypi.Requirements.html","title":"Pypi.Requirements","type":"module"},{"doc":"Scanner scans for python dependencies to run analysis on.","ref":"Pypi.Scanner.html","title":"Pypi.Scanner","type":"module"},{"doc":"query_npm: function that takes in a package and returns an analysis on that package's repository using analyser_module. If the package url cannot be reached, an error is returned.","ref":"Pypi.Scanner.html#query_pypi/1","title":"Pypi.Scanner.query_pypi/1","type":"function"},{"doc":"scan: called when pi? is false, returning an empty list and 0","ref":"Pypi.Scanner.html#scan/2","title":"Pypi.Scanner.scan/2","type":"function"},{"doc":"scan: takes in a path to node dependencies and returns the dependencies mapped to their analysis and the number of dependencies","ref":"Pypi.Scanner.html#scan/3","title":"Pypi.Scanner.scan/3","type":"function"},{"doc":"","ref":"RepoReport.html","title":"RepoReport","type":"module"},{"doc":"","ref":"Results.html","title":"Results","type":"module"},{"doc":"RiskLogic contains the functionality for determining risk based on numeric input values","ref":"RiskLogic.html","title":"RiskLogic","type":"module"},{"doc":"last_commit_size_risk/1: returns a text enumeration for the risk based on the size of the last commit","ref":"RiskLogic.html#commit_change_size_risk/1","title":"RiskLogic.commit_change_size_risk/1","type":"function"},{"doc":"commit_currency_risk/1: returns text enumeration for commit currency risk","ref":"RiskLogic.html#commit_currency_risk/1","title":"RiskLogic.commit_currency_risk/1","type":"function"},{"doc":"contributor_risk/1: returns text enumeration for count","ref":"RiskLogic.html#contributor_risk/1","title":"RiskLogic.contributor_risk/1","type":"function"},{"doc":"functional_contributors_risk/1: returns the enumerated risk based on input contributors list","ref":"RiskLogic.html#functional_contributors_risk/1","title":"RiskLogic.functional_contributors_risk/1","type":"function"},{"doc":"sbom_risk/1: returns text risk level for identified sbom_risk","ref":"RiskLogic.html#sbom_risk/0","title":"RiskLogic.sbom_risk/0","type":"function"},{"doc":"Scan for a SBOM and validate.","ref":"SbomModule.html","title":"SbomModule","type":"module"},{"doc":"","ref":"SbomModule.html#has_sbom?/1","title":"SbomModule.has_sbom?/1","type":"function"},{"doc":"","ref":"SbomModule.html#has_spdx?/1","title":"SbomModule.has_spdx?/1","type":"function"},{"doc":"Scanner scans.","ref":"ScannerModule.html","title":"ScannerModule","type":"module"},{"doc":"","ref":"ScannerModule.html#dependencies/1","title":"ScannerModule.dependencies/1","type":"function"},{"doc":"","ref":"ScannerModule.html#get_report/4","title":"ScannerModule.get_report/4","type":"function"},{"doc":"","ref":"ScannerModule.html#scan/1","title":"ScannerModule.scan/1","type":"function"},{"doc":"Collection of functions for handling time-based conversions.","ref":"TimeHelper.html","title":"TimeHelper","type":"module"},{"doc":"get_commit_delta/1: returns the time between now and the last commit in seconds","ref":"TimeHelper.html#get_commit_delta/1","title":"TimeHelper.get_commit_delta/1","type":"function"},{"doc":"sec_to_days/1: returns a roll-up of days from a number of secs","ref":"TimeHelper.html#sec_to_days/1","title":"TimeHelper.sec_to_days/1","type":"function"},{"doc":"sec_to_str/1: returns a string breakdown of total seconds into weeks, days, hours, minutes and remaining seconds. Examples iex&gt; TimeHelper . sec_to_str ( 5211 ) &quot;1 hr, 26 min, 51 sec&quot;","ref":"TimeHelper.html#sec_to_str/1","title":"TimeHelper.sec_to_str/1","type":"function"},{"doc":"sec_to_weeks/1: returns a roll-up of weeks from a number of secs","ref":"TimeHelper.html#sec_to_weeks/1","title":"TimeHelper.sec_to_weeks/1","type":"function"},{"doc":"","ref":"TimeHelper.html#sum_ts_diff/1","title":"TimeHelper.sum_ts_diff/1","type":"function"},{"doc":"sum_ts_diff/2","ref":"TimeHelper.html#sum_ts_diff/2","title":"TimeHelper.sum_ts_diff/2","type":"function"},{"doc":"CAVEATS: Version 0.7.0 includes a quick scan for the presence of a SBOM, either a bom.xml for CycloneDX or *.spdx / *spdx.rdf for SPDX. Version 0.6.0 includes breaking changes to the analyze function -&gt; upgrading from 0.5.0 to 0.6.0 will require you to pass in a couple extra arguments to the analyze function: AnalyzerModule . analyze ( [ &quot;https://github.com/gtri/lowendinsight&quot; , &quot;https://github.com/gtri/lowendinsight-get&quot; ] , &quot;iex&quot; , DateTime . utc_now ( ) , %{ types : true } ) In version 0.6.0 the DateTime.utc_now() and new options field %{types: true} are required. LowEndInsight is a simple &quot;bus-factor&quot; risk analysis library for Open Source Software which is managed within a Git repository. Provide the git URL and the library will respond with a basic Elixir Map structure report. (There is a desire to make this a struct.) If you are at all concerned about risks associated with upstream dependency requirements LowEndInsight can provide valuable, and actionable information around the likelihood of critical issues being resolved, if ever reported. For example, a repo with a single contributor isn't necessarily bad, but it should be considered with some level of risk. Are you or your organization willing to assume ownership (fork) of the repository to resolve issues yourself? Or if there hasn't been a commit against the source repository, in some significant amount of time, can you assume that it is inactive, or just stable? While, in terms of DevSecOps, we are moving towards automation of vulnerability scanning, this doesn't tell the whole picture. First problem is that not all vulnerabilities are found/known, nor are all reported. So perhaps some risk reduction should be applied at the dependency inclusion steps. Again, the intent of LowEndInsight isn't to say that any upstream Open Source dependency is bad, just that the risks should be smartly weighed, and a deeper understanding of the implications should be gained during the decision to use. LowEndInsight provides a simple mechanism for investigating and applying basic governance (based on a definition of the tolerance level, which you can easily override) and responds with a useful report for integrating into your existing DevSecOps automation. Or, you can easily use LowEndInsight as an ad-hoc reporting tool, running it manually as part of an ADR .","ref":"readme.html","title":"LowEndInsight","type":"extras"},{"doc":"Functional Contributors - we've found that most projects receive a majority of contributions from one or two contributors. This highlights a misconception about a project's number of contributors and some notion of health or maturity. We report both the total number of contributors, and our notion of &quot;functional contributors&quot; making it easy to identify the risk. Commit Currency - we've found that many projects are active, while many are also dormant or stale. This isn't saying anthing of the quality of the project, but actually highlights potential supply-chain issues, e.g., is the project staying current with upstream dependencies updates SBOM presence - we've found that adoption of a standard software-bill-of-materials (SBOM) manifest is lagging, especially in smaller projects. Again, the presence or lack thereof does not indicate quality or maturity, however, it does highlight the need to address provenence and risk management. Recent Commit Change - we've found that project volatility could indicate project instability, but more likely highlights an active project - though it is very difficult to discern this based on amounts of change, and thus should require more due diligence applied when looking at the stability of a dependency. ✗ mix lei . analyze https :/ / github . com / facebook / react | jq { &quot;state&quot; : &quot;complete&quot; , &quot;report&quot; : { &quot;uuid&quot; : &quot;4d1e2b08-7b68-11ea-9ca1-88e9fe666193&quot; , &quot;repos&quot; : [ { &quot;header&quot; : { &quot;uuid&quot; : &quot;4d1dbee8-7b68-11ea-93b9-88e9fe666193&quot; , &quot;start_time&quot; : &quot;2020-04-10T20:15:34.912972Z&quot; , &quot;source_client&quot; : &quot;mix task&quot; , &quot;repo&quot; : &quot;https://github.com/facebook/react&quot; , &quot;library_version&quot; : &quot;&quot; , &quot;end_time&quot; : &quot;2020-04-10T20:17:28.867848Z&quot; , &quot;duration&quot; : 114 } , &quot;data&quot; : { &quot;risk&quot; : &quot;low&quot; , &quot;results&quot; : { &quot;top10_contributors&quot; : [ { &quot;name&quot; : &quot;Paul O’Shannessy&quot; , &quot;merges&quot; : 959 , &quot;email&quot; : &quot;paul@oshannessy.com&quot; , &quot;contributions&quot; : 1777 } , { &quot;name&quot; : &quot;Dan Abramov&quot; , &quot;merges&quot; : 86 , &quot;email&quot; : &quot;dan.abramov@gmail.com&quot; , &quot;contributions&quot; : 1356 } , { &quot;name&quot; : &quot;Sophie Alpert&quot; , &quot;merges&quot; : 392 , &quot;email&quot; : &quot;git@sophiebits.com&quot; , &quot;contributions&quot; : 1265 } , { &quot;name&quot; : &quot;Brian Vaughn&quot; , &quot;merges&quot; : 101 , &quot;email&quot; : &quot;bvaughn@fb.com&quot; , &quot;contributions&quot; : 995 } , { &quot;name&quot; : &quot;Sebastian Markbåge&quot; , &quot;merges&quot; : 141 , &quot;email&quot; : &quot;sebastian@calyptus.eu&quot; , &quot;contributions&quot; : 803 } , { &quot;name&quot; : &quot;Jim Sproch&quot; , &quot;merges&quot; : 327 , &quot;email&quot; : &quot;jsproch@fb.com&quot; , &quot;contributions&quot; : 456 } , { &quot;name&quot; : &quot;Brian Vaughn&quot; , &quot;merges&quot; : 65 , &quot;email&quot; : &quot;brian.david.vaughn@gmail.com&quot; , &quot;contributions&quot; : 363 } , { &quot;name&quot; : &quot;Dominic Gannaway&quot; , &quot;merges&quot; : 6 , &quot;email&quot; : &quot;trueadm@users.noreply.github.com&quot; , &quot;contributions&quot; : 336 } , { &quot;name&quot; : &quot;Pete Hunt&quot; , &quot;merges&quot; : 126 , &quot;email&quot; : &quot;floydophone@gmail.com&quot; , &quot;contributions&quot; : 332 } , { &quot;name&quot; : &quot;Andrew Clark&quot; , &quot;merges&quot; : 2 , &quot;email&quot; : &quot;acdlite@fb.com&quot; , &quot;contributions&quot; : 264 } ] , &quot;recent_commit_size_in_percent_of_codebase&quot; : 0.00032 , &quot;large_recent_commit_risk&quot; : &quot;low&quot; , &quot;functional_contributors_risk&quot; : &quot;low&quot; , &quot;functional_contributors&quot; : 84 , &quot;functional_contributor_names&quot; : [ &quot;yiminghe&quot; , &quot;Marshall Roch&quot; , &quot;Flarnie Marchan&quot; , &quot;Daniel Lo Nigro&quot; , &quot;Philipp Spieß&quot; , &quot;Edvin Erikson&quot; , &quot;Mateusz Burzyński&quot; , &quot;Pete Hunt&quot; , &quot;petehunt&quot; , &quot;Ingvar Stepanyan&quot; , &quot;Jordan Walke&quot; , &quot;Jim&quot; , &quot;chico&quot; , &quot;Rauno Freiberg&quot; , &quot;Stefan Dombrowski&quot; , &quot;Keyan Zhang&quot; , &quot;Benjamin Woodruff&quot; , &quot;Nicolas Gallagher&quot; , &quot;CommitSyncScript&quot; , &quot;Joe Critchley&quot; , &quot;Simen Bekkhus&quot; , &quot;fisherwebdev&quot; , &quot;Andrey Popp&quot; , &quot;Lee Byron&quot; , &quot;Shim Won&quot; , &quot;Christoph Pojer&quot; , &quot;Lucas Cordeiro&quot; , &quot;Bartosz Kaszubowski&quot; , &quot;Sasha Aickin&quot; , &quot;Heaven&quot; , &quot;Charles Marsh&quot; , &quot;Kohei TAKATA&quot; , &quot;Cheng Lou&quot; , &quot;Dustan Kasten&quot; , &quot;Dominic Gannaway&quot; , &quot;Ivan Zotov&quot; , &quot;Sophie Alpert&quot; , &quot;Josh Duck&quot; , &quot;Tim Yung&quot; , &quot;Sunil Pai&quot; , &quot;Timothy Yung&quot; , &quot;Thomas Aylott&quot; , &quot;Isaac Salier-Hellendag&quot; , &quot;iamchenxin&quot; , &quot;Raphael Amorim&quot; , &quot;Brian Vaughn&quot; , &quot;Jinwoo Oh&quot; , &quot;Ivan Babak&quot; , &quot;Nathan Hunzaker&quot; , &quot;Paul O’Shannessy&quot; , &quot;Alex Smith&quot; , &quot;Paul O&#39;Shannessy&quot; , &quot;Sebastian Markbage&quot; , &quot;Tom Occhino&quot; , &quot;Jan Kassens&quot; , &quot;Kunal Mehta&quot; , &quot;Luna Ruan&quot; , &quot;Baraa Hamodi&quot; , &quot;Christopher Chedeau&quot; , &quot;Ben Newman&quot; , &quot;jim&quot; , &quot;Clement Hoang&quot; , &quot;Hristo Kanchev&quot; , &quot;Scott Feeney&quot; , &quot;Connor McSheffrey&quot; , &quot;Brandon Dail&quot; , &quot;Paul Shen&quot; , &quot;Nate Hunzaker&quot; , &quot;Vjeux&quot; , &quot;Jared Forsyth&quot; , &quot;Eli White&quot; , &quot;cpojer&quot; , &quot;Andrew Clark&quot; , &quot;Toru Kobayashi&quot; , &quot;Dan&quot; , &quot;Jeff Morrison&quot; , &quot;Sebastian Markbåge&quot; , &quot;Dan Abramov&quot; , &quot;Rick Beerendonk&quot; , &quot;Andreas Svensson&quot; , &quot;Fabio M. Costa&quot; , &quot;yungsters&quot; , &quot;Ben Alpert&quot; , &quot;Jason Quense&quot; ] , &quot;contributor_risk&quot; : &quot;low&quot; , &quot;contributor_count&quot; : 1505 , &quot;commit_currency_weeks&quot; : 0 , &quot;commit_currency_risk&quot; : &quot;low&quot; , &quot;sbom_risk&quot; : &quot;medium&quot; } , &quot;repo_size&quot; : &quot;185M&quot; , &quot;repo&quot; : &quot;https://github.com/facebook/react&quot; , &quot;project_types&quot; : { &quot;node&quot; : [ &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/art/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/attribute-behavior/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/concurrent/time-slicing/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/dom/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/eslint/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/eslint/proxy/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/expiration/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/fiber-debugger/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/flight/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/browserify/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/browserify/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/brunch/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/brunch/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/rjs/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/rjs/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/systemjs-builder/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/systemjs-builder/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/webpack-alias/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/webpack-alias/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/webpack/dev/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/packaging/webpack/prod/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/fixtures/ssr/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/create-subscription/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/dom-event-testing-library/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/eslint-plugin-react-hooks/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/jest-mock-scheduler/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/jest-react/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/legacy-events/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-art/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-cache/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-client/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-debug-tools/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-core/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-extensions/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-inline/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-shared/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-shared/src/node_modules/react-window/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools-shell/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-devtools/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-dom/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-flight-dom-relay/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-flight-dom-webpack/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-interactions/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-is/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-native-renderer/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-noop-renderer/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-reconciler/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-refresh/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-server/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react-test-renderer/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/react/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/scheduler/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/shared/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/packages/use-subscription/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/scripts/bench/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/scripts/eslint-rules/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/scripts/perf-counters/package.json&quot; , &quot;/tmp/lei-1586549734-63434-1b1so9e/react/scripts/release/package.json&quot; ] } , &quot;git&quot; : { &quot;hash&quot; : &quot;8e13f099ab0c820c6f97547ad08244340e074266&quot; , &quot;default_branch&quot; : &quot;refs/remotes/origin/master&quot; } , &quot;config&quot; : { &quot;medium_large_commit_level&quot; : 0.2 , &quot;medium_functional_contributors_level&quot; : 5 , &quot;medium_currency_level&quot; : 26 , &quot;medium_contributor_level&quot; : 5 , &quot;high_large_commit_level&quot; : 0.3 , &quot;high_functional_contributors_level&quot; : 3 , &quot;high_currency_level&quot; : 52 , &quot;high_contributor_level&quot; : 3 , &quot;critical_large_commit_level&quot; : 0.4 , &quot;critical_functional_contributors_level&quot; : 2 , &quot;critical_currency_level&quot; : 104 , &quot;critical_contributor_level&quot; : 2 , &quot;base_temp_dir&quot; : &quot;/tmp&quot; } } } ] } , &quot;metadata&quot; : { &quot;times&quot; : { &quot;start_time&quot; : &quot;2020-04-10T20:15:34.901638Z&quot; , &quot;end_time&quot; : &quot;2020-04-10T20:17:28.885951Z&quot; , &quot;duration&quot; : 114 } , &quot;risk_counts&quot; : { &quot;low&quot; : 1 } , &quot;repo_count&quot; : 1 } } { &quot;state&quot; : &quot;complete&quot; , &quot;report&quot; : { &quot;uuid&quot; : &quot;caa7f920-aaa3-11ec-9c05-f47b09cc5c9a&quot; , &quot;repos&quot; : [ { &quot;header&quot; : { &quot;uuid&quot; : &quot;caa7c2e8-aaa3-11ec-9481-f47b09cc5c9a&quot; , &quot;start_time&quot; : &quot;2022-03-23T12:21:13.234974Z&quot; , &quot;source_client&quot; : &quot;mix task&quot; , &quot;repo&quot; : &quot;https://github.com/facebook/react&quot; , &quot;library_version&quot; : &quot;&quot; , &quot;end_time&quot; : &quot;2022-03-23T12:21:39.762485Z&quot; , &quot;duration&quot; : 26 } , &quot;data&quot; : { &quot;risk&quot; : &quot;medium&quot; , &quot;results&quot; : { &quot;top10_contributors&quot; : [ { &quot;name&quot; : &quot;Paul O’Shannessy&quot; , &quot;merges&quot; : 959 , &quot;email&quot; : &quot;paul@oshannessy.com&quot; , &quot;contributions&quot; : 1778 } , { &quot;name&quot; : &quot;Dan Abramov&quot; , &quot;merges&quot; : 86 , &quot;email&quot; : &quot;dan.abramov@gmail.com&quot; , &quot;contributions&quot; : 1572 } , { &quot;name&quot; : &quot;Brian Vaughn&quot; , &quot;merges&quot; : 101 , &quot;email&quot; : &quot;bvaughn@fb.com&quot; , &quot;contributions&quot; : 1358 } , { &quot;name&quot; : &quot;Sophie Alpert&quot; , &quot;merges&quot; : 392 , &quot;email&quot; : &quot;git@sophiebits.com&quot; , &quot;contributions&quot; : 1268 } , { &quot;name&quot; : &quot;Sebastian Markbåge&quot; , &quot;merges&quot; : 143 , &quot;email&quot; : &quot;sebastian@calyptus.eu&quot; , &quot;contributions&quot; : 995 } , { &quot;name&quot; : &quot;Andrew Clark&quot; , &quot;merges&quot; : 0 , &quot;email&quot; : &quot;git@andrewclark.io&quot; , &quot;contributions&quot; : 631 } , { &quot;name&quot; : &quot;Jim Sproch&quot; , &quot;merges&quot; : 327 , &quot;email&quot; : &quot;jsproch@fb.com&quot; , &quot;contributions&quot; : 456 } , { &quot;name&quot; : &quot;Dominic Gannaway&quot; , &quot;merges&quot; : 6 , &quot;email&quot; : &quot;trueadm@users.noreply.github.com&quot; , &quot;contributions&quot; : 404 } , { &quot;name&quot; : &quot;Brian Vaughn&quot; , &quot;merges&quot; : 65 , &quot;email&quot; : &quot;brian.david.vaughn@gmail.com&quot; , &quot;contributions&quot; : 363 } , { &quot;name&quot; : &quot;Pete Hunt&quot; , &quot;merges&quot; : 126 , &quot;email&quot; : &quot;floydophone@gmail.com&quot; , &quot;contributions&quot; : 332 } ] , &quot;sbom_risk&quot; : &quot;medium&quot; , &quot;recent_commit_size_in_percent_of_codebase&quot; : 3 e - 05 , &quot;large_recent_commit_risk&quot; : &quot;low&quot; , &quot;functional_contributors_risk&quot; : &quot;low&quot; , &quot;functional_contributors&quot; : 97 , &quot;functional_contributor_names&quot; : [ &quot;Andreas Savvides &lt;asavvides@twitter.com&gt;&quot; , &quot;Pete Hunt &lt;floydophone@gmail.com&gt;&quot; , &quot;Fabio M. Costa &lt;fabiomcosta@gmail.com&gt;&quot; , &quot;Andrew Clark &lt;git@andrewclark.io&gt;&quot; , &quot;Sunil Pai &lt;threepointone@gmail.com&gt;&quot; , &quot;Jeff Morrison &lt;jeff@anafx.com&gt;&quot; , &quot;Simen Bekkhus &lt;sbekkhus91@gmail.com&gt;&quot; , &quot;Christoph Pojer &lt;christoph.pojer@gmail.com&gt;&quot; , &quot;NE-SmallTown &lt;ne_smalltown@163.com&gt;&quot; , &quot;Ray &lt;ray@tomo.im&gt;&quot; , &quot;Nathan Hunzaker &lt;nate.hunzaker@gmail.com&gt;&quot; , &quot;Ingvar Stepanyan &lt;me@rreverser.com&gt;&quot; , &quot;Andreas Svensson &lt;andreas@syranide.com&gt;&quot; , &quot;E-Liang Tan &lt;eliang@eliangtan.com&gt;&quot; , &quot;Dominic Gannaway &lt;dg@domgan.com&gt;&quot; , &quot;Jan Kassens &lt;jan@kassens.net&gt;&quot; , &quot;Jared Forsyth &lt;jared@jaredforsyth.com&gt;&quot; , &quot;Flarnie Marchan &lt;flarnie@users.noreply.github.com&gt;&quot; , &quot;Dan Abramov &lt;dan.abramov@me.com&gt;&quot; , &quot;dependabot[bot] &lt;49699333+dependabot[bot]@users.noreply.github.com&gt;&quot; , &quot;Cheng Lou &lt;chenglou92@gmail.com&gt;&quot; , &quot;Marshall Roch &lt;mroch@fb.com&gt;&quot; , &quot;Toru Kobayashi &lt;koba0004@gmail.com&gt;&quot; , &quot;Rick Hanlon &lt;rickhanlonii@gmail.com&gt;&quot; , &quot;Joe Critchley &lt;joecritch@gmail.com&gt;&quot; , &quot;Joshua Gross &lt;joshua.gross@gmail.com&gt;&quot; , &quot;Sebastian Silbermann &lt;silbermann.sebastian@gmail.com&gt;&quot; , &quot;Luna Ruan &lt;luna@fb.com&gt;&quot; , &quot;Ben Newman &lt;bn@cs.stanford.edu&gt;&quot; , &quot;Sergey Rubanov &lt;chi187@gmail.com&gt;&quot; , &quot;Shim Won &lt;marocchino@gmail.com&gt;&quot; , &quot;Philipp Spiess &lt;hello@philippspiess.com&gt;&quot; , &quot;Sunil Pai &lt;threepointone@fb.com&gt;&quot; , &quot;Vjeux &lt;vjeuxx@gmail.com&gt;&quot; , &quot;Nicolas Gallagher &lt;nicolasgallagher@gmail.com&gt;&quot; , &quot;Ivan Zotov &lt;ivanzotov@gmail.com&gt;&quot; , &quot;Sasha Aickin &lt;xander76@yahoo.com&gt;&quot; , &quot;Jim Sproch &lt;jsproch@fb.com&gt;&quot; , &quot;Dominic Gannaway &lt;trueadm@users.noreply.github.com&gt;&quot; , &quot;Brian Vaughn &lt;brian.david.vaughn@gmail.com&gt;&quot; , &quot;Eli White &lt;github@eli-white.com&gt;&quot; , &quot;Connor McSheffrey &lt;c@conr.me&gt;&quot; , &quot;Scott Feeney &lt;scott@oceanbase.org&gt;&quot; , &quot;Stefan Dombrowski &lt;sdo451@gmail.com&gt;&quot; , &quot;Tay Yang Shun &lt;tay.yang.shun@gmail.com&gt;&quot; , &quot;Paul O’Shannessy &lt;paul@oshannessy.com&gt;&quot; , &quot;Brandon Dail &lt;aweary@users.noreply.github.com&gt;&quot; , &quot;Paul Shen &lt;paul@mnml0.com&gt;&quot; , &quot;Raphael Amorim &lt;rapha850@gmail.com&gt;&quot; , &quot;Bill Fisher &lt;fisherwebdev@gmail.com&gt;&quot; , &quot;Rick Beerendonk &lt;rick@beerendonk.com&gt;&quot; , &quot;Daniel Lo Nigro &lt;daniel@dan.cx&gt;&quot; , &quot;Andrew Clark &lt;acdlite@fb.com&gt;&quot; , &quot;Andrew Clark &lt;github@andrewclark.io&gt;&quot; , &quot;Hristo Kanchev &lt;hristokkanchev@gmail.com&gt;&quot; , &quot;Luna Ruan &lt;lunaris.ruan@gmail.com&gt;&quot; , &quot;Lee Byron &lt;lee@leebyron.com&gt;&quot; , &quot;salazarm &lt;salazarm@users.noreply.github.com&gt;&quot; , &quot;iamchenxin &lt;iamchenxin@gmail.com&gt;&quot; , &quot;Andrey Popp &lt;8mayday@gmail.com&gt;&quot; , &quot;Timothy Yung &lt;yungsters@gmail.com&gt;&quot; , &quot;Kohei TAKATA &lt;kt.koheitakata@gmail.com&gt;&quot; , &quot;Isaac Salier-Hellendag &lt;isaac@fb.com&gt;&quot; , &quot;Jason Quense &lt;monastic.panic@gmail.com&gt;&quot; , &quot;Joseph Savona &lt;joesavona@fb.com&gt;&quot; , &quot;Clement Hoang &lt;clement.hoang24@gmail.com&gt;&quot; , &quot;Sunil Pai &lt;threepointone@oculus.com&gt;&quot; , &quot;Brandon Dail &lt;brandon.dail@formidable.com&gt;&quot; , &quot;Baraa Hamodi &lt;bhamodi@uwaterloo.ca&gt;&quot; , &quot;Sebastian Markbåge &lt;sebastian@calyptus.eu&gt;&quot; , &quot;Jinwoo Oh &lt;arkist@gmail.com&gt;&quot; , &quot;Nicolas Gallagher &lt;necolas@fb.com&gt;&quot; , &quot;jstejada &lt;jstejada@fb.com&gt;&quot; , &quot;Jordan Walke &lt;jordojw@gmail.com&gt;&quot; , &quot;Bartosz Kaszubowski &lt;gosimek@gmail.com&gt;&quot; , &quot;Keyan Zhang &lt;root@keyanzhang.com&gt;&quot; , &quot;Moti Zilberman &lt;motiz88@gmail.com&gt;&quot; , &quot;Charles Marsh &lt;charlie@khanacademy.org&gt;&quot; , &quot;Alex Smith &lt;iqwz@ya.ru&gt;&quot; , &quot;Rauno Freiberg &lt;freiberggg@gmail.com&gt;&quot; , &quot;Tom Occhino &lt;tomocchino@gmail.com&gt;&quot; , &quot;Sophie Alpert &lt;git@sophiebits.com&gt;&quot; , &quot;Lucas Cordeiro &lt;ecdb.lucas@gmail.com&gt;&quot; , &quot;Ivan Babak &lt;babak.john@gmail.com&gt;&quot; , &quot;jddxf &lt;740531372@qq.com&gt;&quot; , &quot;Kunal Mehta &lt;k.mehta@berkeley.edu&gt;&quot; , &quot;Nikita Lebedev &lt;bloomber111@gmail.com&gt;&quot; , &quot;Dustan Kasten &lt;dustan.kasten@gmail.com&gt;&quot; , &quot;Mateusz Burzyński &lt;mateuszburzynski@gmail.com&gt;&quot; , &quot;Thomas Aylott &lt;oblivious@subtlegradient.com&gt;&quot; , &quot;Dan Abramov &lt;dan.abramov@gmail.com&gt;&quot; , &quot;Benjamin Woodruff &lt;github@benjam.info&gt;&quot; , &quot;Josh Duck &lt;josh@fb.com&gt;&quot; , &quot;Andrew Clark &lt;acdlite@me.com&gt;&quot; , &quot;Brian Vaughn &lt;bvaughn@fb.com&gt;&quot; , &quot;Dan Abramov &lt;gaearon@fb.com&gt;&quot; , &quot;yiminghe &lt;yiminghe@gmail.com&gt;&quot; ] , &quot;contributor_risk&quot; : &quot;low&quot; , &quot;contributor_count&quot; : 1671 , &quot;commit_currency_weeks&quot; : 0 , &quot;commit_currency_risk&quot; : &quot;low&quot; } , &quot;repo_size&quot; : &quot;0&quot; , &quot;repo&quot; : &quot;https://github.com/facebook/react&quot; , &quot;project_types&quot; : { &quot;node&quot; : [ &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/art/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/art/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/attribute-behavior/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/attribute-behavior/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/blocks/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/blocks/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/concurrent/time-slicing/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/concurrent/time-slicing/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/dom/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/dom/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/eslint/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/eslint/proxy/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/eslint/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/expiration/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/expiration/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/fiber-debugger/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/fiber-debugger/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/config/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/loader/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/scripts/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/server/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/flight/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-14/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-14/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-15/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-15/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-16/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-16/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-17/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/react-17/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/legacy-jsx-runtimes/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/nesting/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/nesting/src/legacy/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/nesting/src/modern/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/browserify/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/browserify/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/browserify/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/browserify/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/brunch/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/brunch/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/brunch/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/brunch/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/rjs/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/rjs/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/rjs/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/rjs/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/systemjs-builder/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/systemjs-builder/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/systemjs-builder/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/systemjs-builder/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack-alias/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack-alias/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack-alias/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack-alias/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack/dev/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack/dev/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack/prod/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/packaging/webpack/prod/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/ssr/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/ssr/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/ssr2/package-lock.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/ssr2/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/fixtures/ssr2/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/create-subscription/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/dom-event-testing-library/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/eslint-plugin-react-hooks/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/jest-mock-scheduler/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/jest-react/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-art/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-cache/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-client/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-debug-tools/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-core/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-extensions/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-inline/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-shared/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-shared/src/node_modules/react-window/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-shell/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools-timeline/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-devtools/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-dom/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-fetch/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-fs/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-interactions/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-is/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-native-renderer/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-noop-renderer/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-pg/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-reconciler/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-refresh/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server-dom-relay/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server-dom-webpack/esm/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server-dom-webpack/npm/esm/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server-dom-webpack/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server-native-relay/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-server/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-suspense-test-utils/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react-test-renderer/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/react/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/scheduler/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/shared/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/use-subscription/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/packages/use-sync-external-store/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/bench/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/bench/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/devtools/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/devtools/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/eslint-rules/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/perf-counters/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/release/package.json&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/scripts/release/yarn.lock&quot; , &quot;/tmp/lei-1648038073-504683-b6vw7a/react/yarn.lock&quot; ] } , &quot;git&quot; : { &quot;hash&quot; : &quot;de516ca5a635220d0cbe82b8f04003820e3f4072&quot; , &quot;default_branch&quot; : &quot;refs/remotes/origin/main&quot; } , &quot;config&quot; : { &quot;sbom_risk_level&quot; : &quot;medium&quot; , &quot;medium_large_commit_level&quot; : 0.2 , &quot;medium_functional_contributors_level&quot; : 5 , &quot;medium_currency_level&quot; : 26 , &quot;medium_contributor_level&quot; : 5 , &quot;high_large_commit_level&quot; : 0.3 , &quot;high_functional_contributors_level&quot; : 3 , &quot;high_currency_level&quot; : 52 , &quot;high_contributor_level&quot; : 3 , &quot;critical_large_commit_level&quot; : 0.4 , &quot;critical_functional_contributors_level&quot; : 2 , &quot;critical_currency_level&quot; : 104 , &quot;critical_contributor_level&quot; : 2 , &quot;base_temp_dir&quot; : null } } } ] } , &quot;metadata&quot; : { &quot;times&quot; : { &quot;start_time&quot; : &quot;2022-03-23T12:21:13.228056Z&quot; , &quot;end_time&quot; : &quot;2022-03-23T12:21:39.803990Z&quot; , &quot;duration&quot; : 26 } , &quot;risk_counts&quot; : { &quot;medium&quot; : 1 } , &quot;repo_count&quot; : 1 } } NOTE: that the &quot;file://&quot; is also supporting, but presumes that the directory provided is a valid Git clone. Analysis of a file://-based repo will not conclude with the directory structure being removed.","ref":"readme.html#key-metrics","title":"LowEndInsight - Key Metrics","type":"extras"},{"doc":"LowEndInsight available in Hex , the package can be installed by adding lowendinsight to your list of dependencies in mix.exs : def deps do [ { :lowendinsight , &quot;~&gt; 0.5&quot; } ] end NOTE: check hex.pm for the latest version.","ref":"readme.html#installation","title":"LowEndInsight - Installation","type":"extras"},{"doc":"You either need to have Elixir and Erlang installed locally or possibly a container to run stuff in. Mix Task for Scanning in a Mix-based Project It is also possible to drop this in as a library dependency to your Mix-based Elixir project. Simply add the library to your project's dependencies: defp deps do [ { :lowendinsight , &quot;~&gt; 0.5&quot; , except : :prod , runtime : false } ] end Then run mix deps.get , and mix lei.scan . This will produce a report for the dependencies (and transitive dependencies) specified in your Mix definition. You'll get a full report: ➜ lei_scanner_test mix lei . scan { &quot;state&quot; : &quot;complete&quot; , &quot;report&quot; : { &quot;uuid&quot; : &quot;3084c312-65ab-11ea-b49b-88e9fe666193&quot; , &quot;repos&quot; : [ { &quot;header&quot; : { &quot;uuid&quot; : &quot;2fc3853a-65ab-11ea-849f-88e9fe666193&quot; , &quot;start_time&quot; : &quot;2020-03-14T04:20:47.357888Z&quot; , &quot;source_client&quot; : &quot;mix.scan&quot; , &quot;library_version&quot; : &quot;&quot; , &quot;end_time&quot; : &quot;2020-03-14T04:20:50.335877Z&quot; , &quot;duration&quot; : 3 } , &quot;data&quot; : { &quot;risk&quot; : &quot;low&quot; , ... It is also possible to scan against a different repo locally by passing the absolute path to the directory where it is cloned: mix lei . scan / some / path / to / a / git / repo Scanning in a NPM-Based Project Lowendinsight can now be run against NPM-Based projects. To do so, simply clone the repository and run the following from lowendinsight's root directory. mix deps . get mix lei . scan / some / path / to / a / git / repo It is important to note that though lowendinsight works on NPM-based projects, scanning still requires a local installation of Mix. At the least, the above requires an existing package.json file in order to scan the first-degree dependencies of an NPM-based project. A complete scan of both first-degree and transitive dependencies requires a package-lock.json file. In other words, due to how NPM handles dependencies, a complete scan of a repository can only be accomplished if all of its dependencies are listed in package-lock.json . In the scope of package.json , dependencies listed in both devDependencies and dependencies are scanned. Future iterations of lowendinsight could offer the ability to disable devDependencies from being scanned. Mix Task for Generating a Dependencies JSON List mix lei . dependencies / some / path / to / a / Mix - based - project Governance/Parameter Configuration The library uses a baseline configuration for each of the metrics calculated. If you want to set your own, all you need to do is add the :lowendinsight configuration as mentioned below in the Configuration section. Tuning of these defaults will likely happen over time, as analysis continues to run on a large scale. The analysis will be made available here soon. REPL iex - S mix This will get you the iex prompt: Erlang / OTP 22 [ erts - 10.6 . 4 ] [ source ] [ 64 - bit ] [ smp : 4 : 4 ] [ ds : 4 : 4 : 10 ] [ async - threads : 1 ] [ hipe ] [ dtrace ] Interactive Elixir ( 1.10 . 2 ) - press Ctrl + C to exit ( type h ( ) ENTER for help ) iex(1)&gt; AnalyzerModule . analyze &quot;https://github.com/kitplummer/xmpp4rails&quot; , &quot;iex&quot; , %{ types : false } { :ok , %{ data : %{ config : %{ base_temp_dir : &quot;/tmp&quot; , critical_contributor_level : 2 , critical_currency_level : 104 , critical_functional_contributors_level : 2 , critical_large_commit_level : 0.4 , high_contributor_level : 3 , high_currency_level : 52 , high_functional_contributors_level : 3 , high_large_commit_level : 0.3 , medium_contributor_level : 5 , medium_currency_level : 26 , medium_functional_contributors_level : 5 , medium_large_commit_level : 0.2 } , git : %{ default_branch : &quot;refs/remotes/origin/master&quot; , hash : &quot;f47ee5f5ef7fb4dbe3d5d5f54e278ea941cb0332&quot; } , project_types : %{ } , repo : &quot;https://github.com/kitplummer/xmpp4rails&quot; , repo_size : &quot;292K&quot; , results : %{ commit_currency_risk : &quot;critical&quot; , commit_currency_weeks : 584 , contributor_count : 1 , contributor_risk : &quot;critical&quot; , functional_contributor_names : [ &quot;Kit Plummer&quot; ] , functional_contributors : 1 , functional_contributors_risk : &quot;critical&quot; , large_recent_commit_risk : &quot;low&quot; , recent_commit_size_in_percent_of_codebase : 0.00368 , top10_contributors : [ %{ &quot;Kit Plummer&quot; = &gt; 7 } ] , sbom_risk : &quot;low&quot; } , risk : &quot;critical&quot; } , header : %{ duration : 0 , end_time : &quot;2020-03-22T23:45:06.563532Z&quot; , library_version : &quot;&quot; , repo : &quot;https://github.com/kitplummer/xmpp4rails&quot; , source_client : &quot;iex&quot; , start_time : &quot;2020-03-22T23:45:06.078198Z&quot; , uuid : &quot;28a109ba-6c97-11ea-be3d-88e9fe666193&quot; } } } Here's the command that you would paste in to the iex REPL as an example: AnalyzerModule . analyze &quot;https://github.com/kitplummer/xmpp4rails&quot; , &quot;iex&quot; , %{ types : false } Docker You can pass in this lib and configuration settings, into a base Elixir container. From the root directory of a clone of this repo run this: docker run -- rm - v $ PWD :/ app - w / app - it - e LEI_CRITICAL_CURRENCY_LEVEL = 60 elixir :latest bash - c &quot;mix local.hex;mix deps.get;iex -S mix&quot; From iex you can access to the library functions. Erlang / OTP 22 [ erts - 10.6 . 3 ] [ source ] [ 64 - bit ] [ smp : 4 : 4 ] [ ds : 4 : 4 : 10 ] [ async - threads : 1 ] [ hipe ] [ dtrace ] Interactive Elixir ( 1.10 . 0 ) - press Ctrl + C to exit ( type h ( ) ENTER for help ) iex(1)&gt; AnalyzerModule . analyze ( [ &quot;https://github.com/kitplummer/xmpp4rails&quot; ] , &quot;iex&quot; , DateTime . utc_now ( ) , %{ types : true } ) { :ok , % { metadata : %{ repo_count : 1 , risk_counts : %{ &quot;critical&quot; = &gt; 1 } , times : %{ duration : 1 , end_time : &quot;2020-02-08T04:35:35.109053Z&quot; , start_time : &quot;2020-02-08T04:35:34.078971Z&quot; } } , report : % { repos : [ %{ ... } Mix Tasks for Analyzing Repos There is also an Elixir mix task that you can use to access the AnalyzeModule.analyze(url, client) function. So if have this repo cloned: mix lei.analyze mix lei . analyze https :/ / github . com / kitplummer / xmpp4rails | jq This will return: { &quot;state&quot;: &quot;complete&quot;, &quot;report&quot;: { &quot;uuid&quot;: &quot;86ac4538-4a28-11ea-897f-82dd17abe001&quot;, &quot;repos&quot;: [ { &quot;header&quot;: { &quot;uuid&quot;: &quot;86ac38f4-4a28-11ea-89c1-82dd17abe001&quot;, &quot;start_time&quot;: &quot;2020-02-08T04:07:29.736126Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, ... } There also is a batch/bulk processor: mix lei.bulk_analyze mix lei . bulk_analyze &quot;./test/scan_list_test&quot; | jq The expected file is a simple list of URLs, one per line like this: https :/ / github . com / gtri / lowendinsight https :/ / github . com / gtri / lowendinsight - get GitHub Action Lowendinsight can also be added to a GitHub workflow as an action. In its current state, it works against both NPM and Mix based projects. When run against a GitHub repository, a .json file will be generated of the format lei--Y-m-d--H-M-S.json and pushed to that repository's root directory by default. This action currently exists in the develop branch. The following is an example usage: name: LEI on: push: branches: [ master ] pull_request: branches: [ master ] jobs: build: runs-on: ubuntu-latest steps: - uses: actions/checkout@v2 - uses: actions/checkout@master with: persist-credentials: false # otherwise, the token used is the GITHUB_TOKEN, instead of your personal token fetch-depth: 0 # otherwise, you will fail to push refs to dest repo - name: Generate Report uses: gtri/lowendinsight@gha with: github_token: ${{ secrets.GITHUB_TOKEN }} branch: main Inputs name value default description github_token string Token for the repo. Can be passed in using ${{ secrets.GITHUB_TOKEN }} . branch string 'master' Destination branch to push changes. force boolean false Determines if force push is used. tags boolean false Determines if --tags is used. directory string '.' Directory to change to before pushing. | repository | string | '' | Repository name. Default or empty repository name represents current github repository. If you want to push to other repository, you should make a [personal access token] Privacy This action does not, nor will it ever, collect user data. Any repository used is Lowendinsight's analysis is cloned and deleted without any information being collected by GTRI nor sent to a third party. LowEndInsight REST-y API Also, there is a sister project that wraps this library and provides an HTTP-based interface. https://github.com/gtri/lowendinsight-get","ref":"readme.html#running","title":"LowEndInsight - Running","type":"extras"},{"doc":"API available at: https://hexdocs.pm/lowendinsight/readme.html#content This is the library piece of the puzzle. As mentioned above there is an HTTP API available as well. The library is written in Elixir. mix docs will generate static docs available locally within the repo's root, in the docs/ subdirectory. JSON Schema LowEndInsight makes available the API's schema in JSON form, which can be found in the schema/ subdirectory. In addition, the schema docs are available in schema/docs as Markdown. A Note about the metrics used Recent commit size: This is a measure of how large the most recent commit is in relatino to the size of the codebase. The idea being that a large recent commit is much more likely to be bug filled than a relatively small commit. Functional Contributors: A functional contributor is one that contributes above a certain percentage of commits equal to or greater than their &quot;fair&quot; share. Simply put, a contributor is counted as a functional contributor if the proportion of their commits to the total commits is greater than or equal to 1 / the total number of committers. If everyone committed the same amount, everyone would be a functional contributor. Currency is a bit of insight into the activity of the source repo. This value as a measure of risk, again, isn't to state that the repo is bad. The project simply could be stable. But, it could also mean that the project is unmaintained and that as an attribute of the decision making process around whether to not consume should be considered. risk is a top-level key that contains the &quot;rolled up&quot; risk, the highest value pulled from any of the discrete analysis items. Configuration LowEndInsight allows for customization of the risk levels, to determine &quot;low&quot;, &quot;medium&quot;, &quot;high&quot; and &quot;critical&quot; acceptance. The library reads this configuration from config.exs (or dev|test|prod.exs) as seen here, or as providing in environment variables. config :lowendinsight , ## Contributor in terms of discrete users ## NOTE: this currently doesn&#39;t discern same user with different email critical_contributor_level : String . to_integer ( System . get_env ( &quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot; ) || &quot;2&quot; ) , high_contributor_level : System . get_env ( &quot;LEI_HIGH_CONTRIBUTOR_LEVEL&quot; ) || 3 , medium_contributor_level : System . get_env ( &quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot; ) || 5 , ## Commit currency in weeks - is the project active. This by itself ## may not indicate anything other than the repo is stable. The reason ## we&#39;re reporting it is relative to the likelihood vulnerabilities ## getting fix in a timely manner critical_currency_level : String . to_integer ( System . get_env ( &quot;LEI_CRITICAL_CURRENCY_LEVEL&quot; ) || &quot;104&quot; ) , high_currency_level : String . to_integer ( System . get_env ( &quot;LEI_HIGH_CURRENCY_LEVEL&quot; ) || &quot;52&quot; ) , medium_currency_level : String . to_integer ( System . get_env ( &quot;LEI_MEDIUM_CURRENCY_LEVEL&quot; ) || &quot;26&quot; ) , ## Percentage of changes to repo in recent commit - is the codebase ## volatile in terms of quantity of source being changed critical_large_commit_level : String . to_float ( System . get_env ( &quot;LEI_CRITICAL_LARGE_COMMIT_LEVEL&quot; ) || &quot;0.40&quot; ) , high_large_commit_level : String . to_float ( System . get_env ( &quot;LEI_HIGH_LARGE_COMMIT_LEVEL&quot; ) || &quot;0.30&quot; ) , medium_large_commit_level : String . to_float ( System . get_env ( &quot;LEI_MEDIUM_LARGE_COMMIT_LEVEL&quot; ) || &quot;0.20&quot; ) , ## Bell curve contributions - if there are 30 contributors ## but 90% of the contributions are from 2... critical_functional_contributors_level : String . to_integer ( System . get_env ( &quot;LEI_CRITICAL_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot; ) || &quot;2&quot; ) , high_functional_contributors_level : String . to_integer ( System . get_env ( &quot;LEI_HIGH_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot; ) || &quot;3&quot; ) , medium_functional_contributors_level : String . to_integer ( System . get_env ( &quot;LEI_MEDIUM_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot; ) || &quot;5&quot; ) , ## Jobs per available core for defining max concurrency. This value ## will be used to set the max_concurrency value. jobs_per_core_max : String . to_integer ( System . get_env ( &quot;LEI_JOBS_PER_CORE_MAX&quot; ) || &quot;2&quot; ) To override with an environment variable you just need to have it set: LEI_CRITICAL_CURRENCY_PAR_LEVEL = 60 mix lei . scan If you receive an error in the report with the following (or similar missing environment configuration variable) - the required configuration for LowEndInsight hasn't been made available: could not fetch application environment :critical_contributor_level for application :lowendinsight because the application was not loaded / started . If your application depends on :lowendinsight at runtime , make sure to load / start it or list it under :extra_applications in your mix . exs file","ref":"readme.html#docs","title":"LowEndInsight - Docs","type":"extras"},{"doc":"Thanks for considering, we need your contributions to help this project come to fruition. Here are some important resources: Bugs? Issues is where to report them Style The repo includes auto-formatting, please run mix format to format to the standard style prescribed by the Elixir project: https://hexdocs.pm/mix/Mix.Tasks.Format.html https://github.com/christopheradams/elixir_style_guide Code docs for functions are expected. Examples are a bonus: https://hexdocs.pm/elixir/writing-documentation.html Testing Required. Please write ExUnit test for new code you create. Use mix test --cover to verify that you're maintaining coverage. Github Actions Just getting this built-out. But the bitbucket-pipeline config is still here too. Submitting changes Please send a Pull Request with a clear list of what you've done and why. Please follow Elixir coding conventions (above in Style) and make sure all of your commits are atomic (one feature per commit). Always write a clear log message for your commits. One-line messages are fine for small changes, but bigger changes should look like this: $ git commit -m &quot;A brief summary of the commit &gt; &gt; A paragraph describing what changed and its impact.&quot; JSON Schema The JSON schema found in schema is and should be used to validate the main analysis interfaces' input and expected outputs. Any modifications in implementations should also be made to the schemas and verified/validated by tests. There is an external tool used to do the schema docs conversion: jsonschema2md -d schema/ -o schema/docs . If you make a modification to the schema please run the tool to update the docs with the submission. jsonschema2md is a Node.js tool.","ref":"readme.html#contributing","title":"LowEndInsight - Contributing","type":"extras"},{"doc":"BSD 3-Clause. See https://opensource.org/licenses/BSD-3-Clause or LICENSE file for details. There is code in this project [ mixfile.ex and encoder.ex ], taken from mix-deps-json , that is copyright: Copyright (c) 2016 Andrew Nesbitt. Blatant attribution: https://github.com/andrew And licensed with the MIT license. See the mix-deps-json for more details. For a bit of insight into the licensing part of inclusion within another licensed repo, there's this , which is really interesting. The logic for pulling the code in versus the project as a dependency is that mix-deps-json is really a server I the transitive dependencies aren't worth the weight.","ref":"readme.html#license","title":"LowEndInsight - License","type":"extras"}]